package p2pclient;

import java.rmi.RemoteException;
import javax.swing.JOptionPane;

/**
 * Classe che implementa il metodo run dell'interfaccia Runnable
 * e crea un'istanza di C2C_server
 *@see p2pclient.C2C_server
 */
public class ThreadRmiRegistryFile implements Runnable {

    /**
     * Variabile boolean per attivare il degug
     */
    public static boolean dbg = true;

    /**
     * Implementazione del metodo run che tramite il comando rmi crea lo stub
     * e lo skeleton di C2C_server e successivamente crea un'istanza di C2C_server
     *@see p2pclient.C2C_server
     */
    public void run(){
        try
                {
                    String ap = p2putility.Config.r_currentpath(); //senza spazi e' ok
                    if(ap!=null)
                        if(ap.length()>0)
                            if(ap.contains((CharSequence)" ")) ap = ""; // con no
                    
                    String cp = p2putility.Config.r_classpath();
                    if(cp!=null)
                        if(cp.length()>0)
                            cp = cp.substring(1);

                    String rp = p2putility.Config.r_rmicpath();
                    String np = "p2pclient.C2C_server";

                    if (dbg) p2putility.Util.logClient(rp+"rmic -classpath "+ap+cp+" -d "+ap+cp+" "+np);

                    Process pr1 = Runtime.getRuntime().exec(rp+"rmic -classpath "+ap+cp+" -d "+ap+cp+" "+np);


                }
                catch(Exception e)
                {
                    JOptionPane.showMessageDialog(null,"Errore nell'esecuzione di 'rmic'.\n"+e,"Errore",0);
                    if(dbg) p2putility.Util.logClient("Errore nell'esecuzione di 'rmic'.\n"+e);
                    return;
                }
                finally
                {
                    try{
                        p2pclient.C2C_server.main(null);
                    }
                    catch (RemoteException ex) {
                         p2putility.Util.logClient("ThradRmiRegistryFile error:\n"+ex);
                     }
                }

                return;
    }


}
